{- |
Module      :  $Header$
Description :  Provides basic help functionality.
Author      :  Nils 'bash0r' Jonsson
Copyright   :  (c) 2015 Nils 'bash0r' Jonsson
License     :  MIT

Maintainer  :  aka.bash0r@gmail.com
Stability   :  unstable
Portability :  non-portable (Portability is untested.)

Provides basic help functionality for the headergen executable.
-}
module Headergen.Commands.Help
( command
, help
) where


import Headergen.Messages

import qualified Headergen.Commands.Creation       as Creation
import qualified Headergen.Commands.Initialization as Initialization


command :: [String] -> IO ()
command ["all"   ] = do
  command []
  Creation.help
  Initialization.help
  help
command ["init"  ] = do
  command []
  Initialization.help
command ["create"] = do
  command []
  Creation.help
command ["help"  ] = do
  command []
  help
command _          = do
  putStrLn "Usage: headergen {help [all|COMMAND]|init|create LANGUAGE TEMPLATE MODULE}"
  putStrLn ""

help :: IO ()
help = do
  putStrLn "  headergen help"
  putStrLn "    --> shows this help information"
  putStrLn "  headergen help COMMAND"
  putStrLn "    --> shows detailed help information"

